#! /usr/bin/python

import sys

__python_keywords = ['and', 'as', 'assert', 'break', 'class', 'continue', 'def', 'del', 'elif', 'else', 'except', 'exec', 'finally', 'for', 'from', 'global', 'if', 'import', 'in', 'is', 'lambda', 'not', 'or', 'pass', 'print', 'raise', 'return', 'try', 'while', 'with', 'yield']
__python_constants = ["True", "False", "None", "NotImplemented", "Ellipsis"]
__python_siteconstants = ["quit", "exit", "help", "copyright", "license", "credits"]
_ccredits = " "*15+"Python Console with Integrated Autocorrect\n"+" "*26+"Coding: Skyler Lehmkuhl\n"+" "*21+"Inspiration: Philip Mothes\n\n"
credits._Printer__data = _ccredits+credits._Printer__data
print _ccredits

if len(sys.argv)>1:
	_file = open(sys.argv[1])

def levenshtein_enhanced( word1, word2 ):
	columns = len(word1) + 1
	rows = len(word2) + 1

	# build first row
	currentRow = [0]
	for column in xrange( 1, columns ):
		currentRow.append( currentRow[column - 1] + 1 )

	for row in xrange( 1, rows ):
		previousRow = currentRow
		currentRow = [ previousRow[0] + 1 ]

		for column in xrange( 1, columns ):

			insertCost = currentRow[column - 1] + 7
			deleteCost = previousRow[column] + 7

			if word1[column - 1] != word2[row - 1]:
				replaceCost = previousRow[ column - 1 ]+1
			else:                
				replaceCost = previousRow[ column - 1 ]

			currentRow.append( min( insertCost, deleteCost, replaceCost ) )

	return currentRow[-1]
_inputtable = True
while True:
	try:
		if _inputtable:
			if len(sys.argv)>1:
				_input = _file.readline()
			else:
				_input = raw_input(">>> ")
			if _input.startswith("def ") \
				or _input.startswith("if ") \
				or _input.startswith("try:") \
				or _input.startswith("for") \
				or _input.startswith("while") \
				or _input.startswith("class"):
					_newinput = "\n"
					while not _newinput=="":
						if len(sys.argv)>1:
							_input = _file.readline()
						else:
							_newinput = raw_input("... ")
						_input = _input+"\n"+_newinput
		try:
			print eval(_input)
		except SyntaxError:
			exec(_input)
		_inputtable = True
	except NameError, _e:
		print _e
		_name = _e.args[0].split("'")[1]
		_lowestval = min(10, len(_name))
		_lowest = None
		for i in dir():
			if i.startswith("_"):
				continue
			_dist = levenshtein_enhanced(_name, i)
			if _dist<_lowestval:
				_lowestval = _dist
				_lowest = i
		for i in dir(__builtins__):
			if i.startswith("_"):
				continue
			_dist = levenshtein_enhanced(_name, i)
			if _dist<_lowestval:
				_lowestval = _dist
				_lowest = i
		for i in __python_constants:
			_dist = levenshtein_enhanced(_name, i)
			if _dist<_lowestval:
				_lowestval = _dist
				_lowest = i
		for i in __python_siteconstants:
			_dist = levenshtein_enhanced(_name, i)
			if _dist<_lowestval:
				_lowestval = _dist
				_lowest = i
		if not _lowest==None:
			print "Correcting '"+_name+"' to '"+_lowest+"'."
			_input = _input.replace(_name, _lowest)
			_inputtable = False
		else:
			print "Could not correct '"+_name+"' to anything."
			print _e
			_inputtable = True
	except SyntaxError, e:
		#print e.msg
		_inputl = _input.split("\n")
		_input = _input+"\n"
		_parens = 0
		_curlies = 0
		_brackets = 0
		total = 0
		singles = False
		doubles = False
		escape = False
		for i in _input:
			wasescape = escape
			if i=="(":
				_parens+=1
				total+=1
			elif i==")":
				_parens-=1
			if i=="{":
				_curlies+=1
				total+=1
			elif i=="}":
				_curlies-=1
			if i=="[":
				_brackets+=1
				total+=1
			elif i=="]":
				_brackets-=1
			elif i=="'" and not (doubles or escape):
				singles = not singles
			elif i=='"' and not (singles or escape):
				doubles = not doubles
			elif i=="\\" and not escape:
				escape=True
			elif i=="\n":
				if singles:
					print "Adding missing '."
					_input = _input[:_input.index(i)]+"'"+_input[_input.index(i):]
					_inputtable = False
				elif doubles:
					print 'Adding missing ".'
					_input = _input[:_input.index(i)]+'"'+_input[_input.index(i):]
					_inputtable = False
					
			if wasescape:
				escape=False
			if escape and not singles and not doubles and not _input[_input.index(i)+1]=="\n":
				print "Escape character (\"\\\") not escaping anything!"
				_input = _input[:_input.index(i)]+_input[_input.index(i)+1:]
				print "Correcting to '"+_input+"' which may not be what you meant."
				_inputtable = False
			if _parens<0 and total==0:
				print "Found ')' without matching '('. Correcting to '('."
				_parens+=2
				_input = _input[:_input.index(i)]+"("+_input[_input.index(i)+1:]
				print _input
				_inputtable = False
			if _curlies<0 and total==0:
				print "Found '}' without matching '{'. Correcting to '{'."
				_curlies+=2
				_input = _input[:_input.index(i)]+"{"+_input[_input.index(i)+1:]
				print _input
				_inputtable = False
			if _brackets<0 and total==0:
				print "Found ']' without matching '['. Correcting to '['."
				_brackets+=2
				_input = _input[:_input.index(i)]+"["+_input[_input.index(i)+1:]
				print _input
				_inputtable = False
		if _parens<0:
			print "Found ')' without matching '('. Deleting it."
			_input = _input[:_input.rindex(")")-1]+_input[_input.rindex(")"):]
			print _input
			_inputtable = False
		if _curlies<0:
			print "Found '}' without matching '{'. Deleting it."
			_input = _input[:_input.rindex("}")-1]+_input[_input.rindex("}"):]
			print _input
			_inputtable = False
		if _brackets<0:
			print "Found ']' without matching '['. Deleting it."
			_input = _input[:_input.rindex("]")-1]+_input[_input.rindex("]"):]
			print _input
			_inputtable = False
		#if e.offset==0:
		if _parens>0:
			print "Extra '('. Adding a ')'."
			_inputl[e.lineno-1] = _inputl[e.lineno-1]+")"
			_input = "\n".join(_inputl)
			print _input
			_inputtable = False
		if _curlies>0:
			print "Extra '{'. Adding a '}'."
			_inputl[e.lineno-1] = _inputl[e.lineno-1]+"}"
			_input = "\n".join(_inputl)
			print _input
			_inputtable = False
		if _brackets>0:
			print "Extra '['. Adding a ']'."
			_inputl[e.lineno-1] = _inputl[e.lineno-1]+"]"
			_input = "\n".join(_inputl)
			print _input
			_inputtable = False
		if _inputtable==True:
			_errchar = _inputl[e.lineno-1][e.offset-1]
				
			if _errchar=="=" and _inputl[e.lineno-1].startswith("if"):
				print "Line "+str(e.lineno)+": You used a single '=' in an if statement. Correcting to '=='."
				_inputl[e.lineno-1]=_inputl[e.lineno-1][:e.offset-1]+"="+_inputl[e.lineno-1][e.offset-1:]
				_input = "\n".join(_inputl)
				_inputtable = False
			elif _errchar==":" and _inputl[e.lineno-1].startswith("def") and e.offset>len(_inputl[e.lineno-1])-2:
				if "(" in _inputl[e.lineno-1]:
					print "Adding missing ')'."
					_inputl[e.lineno-1]=_inputl[e.lineno-1][:e.offset-1]+")"+_inputl[e.lineno-1][e.offset-1:]
					_input = "\n".join(_inputl)
					_inputtable = False
				else:
					print "Adding parentheses to function definition."
					_inputl[e.lineno-1]=_inputl[e.lineno-1][:e.offset-1]+"()"+_inputl[e.lineno-1][e.offset-1:]
					_input = "\n".join(_inputl)
					_inputtable = False
			else:
				print _errchar
	except Exception, e:
		print "Error: ",e
